﻿using System.Collections.Generic;
using System.Dynamic;
using System.Linq;

namespace DynamicViewModel.Tests.TestTypes
{
    internal sealed class SimpleDynamicObject : DynamicObject
    {
        private readonly Dictionary<string, object> _dictionary = new Dictionary<string, object>();

        public override bool TrySetMember(SetMemberBinder binder, object value)
        {
            _dictionary[binder.Name] = value;
            return true;
        }

        public override bool TryGetMember(GetMemberBinder binder, out object result)
        {
            return _dictionary.TryGetValue(binder.Name, out result);
        }

        public override IEnumerable<string> GetDynamicMemberNames()
        {
            return _dictionary.Keys.AsEnumerable();
        }
    }
}       